Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jdbc.datasource.lookup
Class AbstractRoutingDataSource

    java.lang.Object
      org.springframework.jdbc.datasource.AbstractDataSource
          org.springframework.jdbc.datasource.lookup.AbstractRoutingDataSource

All Implemented Interfaces:
  DataSource, InitializingBean

Direct Known Subclasses:
  IsolationLevelDataSourceRouter

    public abstract class AbstractRoutingDataSource

extends AbstractDataSource
implements InitializingBean

Abstract DataSource implementation that routes `getConnection()` calls to one of various target DataSources based on a lookup key. The latter is usually (but not necessarily) determined through some thread-bound transaction context.

Since:
  2.0.1
Author:
  Juergen Hoeller
See Also:
  `setTargetDataSources(java.util.Map)`, `setDefaultTargetDataSource(java.lang.Object)`, `determineCurrentLookupKey()`

Field Summary

Fields inherited from class org.springframework.jdbc.datasource.AbstractDataSource
`logger`

Constructor Summary
`AbstractRoutingDataSource()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`protected abstract Object` | `determineCurrentLookupKey()` Determine the current lookup key.
`protected DataSource` | `determineTargetDataSource()` Retrieve the current target DataSource.
`Connection` | `getConnection()`
`Connection` | `getConnection(String username, String password)`
`protected DataSource` | `resolveSpecifiedDataSource(Object dataSource)` Resolve the specified data source object into a DataSource instance.
`protected Object` | `resolveSpecifiedLookupKey(Object lookupKey)` Resolve the given lookup key object, as specified in the `targetDataSources` map, into the actual lookup key to be used for matching with the `current lookup key`.
`void` | `setDataSourceLookup(DataSourceLookup dataSourceLookup)` Set the DataSourceLookup implementation to use for resolving data source name Strings in the `targetDataSources` map.
`void` | `setDefaultTargetDataSource(Object defaultTargetDataSource)` Specify the default target DataSource, if any.
`void` | `setTargetDataSources(Map targetDataSources)` Specify the map of target DataSources, with the lookup key as key.

Methods inherited from class org.springframework.jdbc.datasource.AbstractDataSource
`getLoginTimeout, getLogWriter, setLoginTimeout, setLogWriter`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AbstractRoutingDataSource

    public AbstractRoutingDataSource()

Method Detail

### setTargetDataSources

    public void setTargetDataSources(Map targetDataSources)

  Specify the map of target DataSources, with the lookup key as key. The mapped value can either be a corresponding `DataSource` instance or a data source name String (to be resolved via a `DataSourceLookup`.

  The key can be of arbitrary type; this class implements the generic lookup process only. The concrete key representation will be handled by `resolveSpecifiedLookupKey(Object)` and `determineCurrentLookupKey()`.

### setDefaultTargetDataSource

    public void setDefaultTargetDataSource(Object defaultTargetDataSource)

  Specify the default target DataSource, if any. The mapped value can either be a corresponding `DataSource` instance or a data source name String (to be resolved via a `DataSourceLookup`.

  This DataSource will be used as target if none of the keyed `targetDataSources` match the `determineCurrentLookupKey()` current lookup key}.

### setDataSourceLookup

    public void setDataSourceLookup(DataSourceLookup dataSourceLookup)

  Set the DataSourceLookup implementation to use for resolving data source name Strings in the `targetDataSources` map.

  Default is a `JndiDataSourceLookup`, allowing the JNDI names of application server DataSources to be specified directly.

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### resolveSpecifiedDataSource

    protected DataSource resolveSpecifiedDataSource(Object dataSource)
                                             throws IllegalArgumentException

  Resolve the specified data source object into a DataSource instance.

  The default implementation handles DataSource instances and data source names (to be resolved via a `DataSourceLookup`).

  Parameters:
    `dataSource` - the data source value object as specified in the `targetDataSources` map
  Returns:
    the resolved DataSource (never `null`)
  Throws:
    `IllegalArgumentException` - in case of an unsupported value type

### getConnection

    public Connection getConnection()
                             throws SQLException

  Specified by:
    `getConnection` in interface `DataSource`
  Throws:
    `SQLException`

### getConnection

    public Connection getConnection(String username,
                                    String password)
                             throws SQLException

  Specified by:
    `getConnection` in interface `DataSource`
  Throws:
    `SQLException`

### determineTargetDataSource

    protected DataSource determineTargetDataSource()

  Retrieve the current target DataSource. Determines the `current lookup key`, performs a lookup in the `targetDataSources` map, falls back to the specified `default target DataSource` if necessary.

  See Also:
    `determineCurrentLookupKey()`

### resolveSpecifiedLookupKey

    protected Object resolveSpecifiedLookupKey(Object lookupKey)

  Resolve the given lookup key object, as specified in the `targetDataSources` map, into the actual lookup key to be used for matching with the `current lookup key`.

  The default implementation simply returns the given key as-is.

  Parameters:
    `lookupKey` - the lookup key object as specified by the user
  Returns:
    the lookup key as needed for matching

### determineCurrentLookupKey

    protected abstract Object determineCurrentLookupKey()

  Determine the current lookup key. This will typically be implemented to check a thread-bound transaction context.

  Allows for arbitrary keys. The returned key needs to match the stored lookup key type, as resolved by the `resolveSpecifiedLookupKey(java.lang.Object)` method.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2007 The Spring Framework.